#region Using directives

using System;
using System.Text;
using System.Runtime.InteropServices;

#endregion


namespace AdaptorsInfoDevice
{
    public unsafe class Adaptors
    {
        [DllImport("iphlpapi.dll")]
        private static extern int GetAdaptersInfo(byte[] pAdapterInfo, ref uint pOutBufLen);


        public Adaptors()
        {
        }

        public unsafe byte[] Info(int adapterIndex)
        {
            uint pOutBufLen = 0;
            GetAdaptersInfo((byte[])null, ref pOutBufLen);
            byte[] pAdapterInfo = new byte[pOutBufLen];
            int adaptersInfo = GetAdaptersInfo(pAdapterInfo, ref pOutBufLen);
            if (adaptersInfo != 0)
            {
                throw new Exception(adaptersInfo.ToString());
            }
            return pAdapterInfo;

            fixed (byte* numRef = pAdapterInfo)
            {
                byte* numPtr = numRef;
                uint num3 = 0;
                do
                {
                    num3 = *((uint*)numPtr);
                    byte* pData = numPtr;
                    numPtr += 0x19c;
                    int num4 = *((int*)numPtr);
                    if (num4 == adapterIndex)
                    {
                        byte[] info = new byte[640];
                        Marshal.Copy(new IntPtr((void*)pData), info, 0, 640);
                        return info;
                    }
                    uint num5 = num3 - ((uint)numPtr);
                    numPtr += num5;
                }
                while (num3 != 0);
                return null;
            }
        }

    }
}
